#!/usr/bin/perl
use Fcntl;
use HTML::Template;
$| = 1;
use CGI::Carp qw (fatalsToBrowser);
use CGI;
$thisCGI = CGI->new ();
if (! -e 'temp/')
{
	mkdir ('temp', 0777);
	chmod (0777, 'temp');
}
my $path = './';
my $forums = read_file ($path . 'tmpl/allforums.cgi');
my @forums = split (/\n/, $forums);
my $param_loop = [];
my $param_loop_fs = [];
my $startno = 0;
my $num = 0;
my $lastcategoryplace = -1;
my $lastcategory;
foreach my $line (@forums)
{
	chomp $line;
	next if ($line eq '');
	my ($forumid, $category, $categoryplace, $forumname, $forumdescription, $forummoderator ,$htmlstate ,$idmbcodestate ,$privateforum, $startnewthreads ,$lastposter ,$lastposttime, $threads, $posts, $forumgraphic,$tmp,$tmp,$forumpass,$hiddenforum,$indexforum,$teamlogo,$teamurl, $fgwidth, $fgheight, $paymoney, $todayforumpost, $miscad5) = split (/\t/, $line);
	next if ($forumid !~ /^[0-9]+$/ || $category =~/^childforum-[0-9]+/);
	push (@{$param_loop_fs}, 
		{
			'forumname' => $forumname,
			'TABLE_WIDTH' => '760',
			'fav_add' => '<img src="http://www.easunstudio.com/esbnocgi/images/fav_add.gif">',
		}
	);
	if (($categoryplace ne $lastcategoryplace) && ($lastcategoryplace ne '-1'))
	{
		my @part_param_loop_fs = @{$param_loop_fs}[$startno .. $num-1];
		push (@{$param_loop}, 
			{
				'thiscat_fs' => \@part_param_loop_fs,
				'TABLE_WIDTH' => '760',
				'IMAGE_URL' => 'http://www.easunstudio.com/esbnocgi',
				'cat_name' => $lastcategory,
				'cat_id' => $lastcategoryplace,
			}
		);
		$startno = $num;
	}
	$lastcategoryplace = $categoryplace;
	$lastcategory = $category;
	$num++;
}
my @part_param_loop_fs = @{$param_loop_fs}[$startno .. $num-1];
push (@{$param_loop}, 
	{
		'thiscat_fs' => \@part_param_loop_fs,
		'TABLE_WIDTH' => '760',
		'IMAGE_URL' => 'http://www.easunstudio.com/esbnocgi',
		'cat_name' => $lastcategory,
		'cat_id' => $categoryplace,
	}
);


my $tmpl = HTML::Template->new
(
	path => 'tmpl/',
	filename => 'boards.htm',
	loop_context_vars => 1,
	file_cache => 1, 
	file_cache_dir => 'temp',
	file_cache_dir_mode => 0777,
	double_file_cache => 1,
);

$tmpl -> param
(
	'cat_loop' => \@{$param_loop}
);
my $output .=  $tmpl->output;
print $thisCGI->header( -charset => 'gb2312' );
print $output;
exit;

sub read_file
{
	my $file = shift;
	my $size = (-s $file);
	if ($size)
	{
		sysopen (FILE, $file, O_RDONLY, 0666) or return 0;
		sysseek (FILE, 0, 0);
		sysread (FILE, my $filedata, $size);
		close(FILE);
		$filedata =~ s/\r//g;
		return $filedata;
	} else {
		return undef;
	}
}
1;